import controlP5.*;
import java.util.ArrayList;
import processing.core.*; 

public class Controls
{
  private Controls(){
  }

  static public ControlP5 createGUI(PApplet myPApplet, ControlP5 controlP5, ArrayList songList)
  {
   
    controlP5.setAutoDraw(false);
    ScrollList l = controlP5.addScrollList("songList",1,11,myPApplet.round(myPApplet.width * .4f -1),myPApplet.round(myPApplet.height * .80f));

    l.setLabel("Choose A Track");
    l.setId(101);
    for(int x = 0; x < songList.size(); x++) {
      String[] curSongInfo = (String[])songList.get(x);
      String curTitle = curSongInfo[0];
      if (curTitle.length() > 80) {
       curTitle = curTitle.substring(0,40).trim() + "..."; 
      }
      controlP5.Button b = l.addItem(curTitle, x);
      b.setId(x);
    }
    
    int lastX = myPApplet.round(myPApplet.width * .4f + 1);

    ScrollList l1 = controlP5.addScrollList("visList",lastX,11,myPApplet.round(myPApplet.width * .2f -1), 200);
    l1.setLabel("Choose A Visualizer");
    l1.setId(102);
    controlP5.Button b;
    b = l1.addItem("Tower", 0);
    b.setId(0);
    b = l1.addItem("Block Spin", 1);
    b.setId(1);
    b = l1.addItem("Box Tower", 2);
    b.setId(2);
   b = l1.addItem("Block Spiral", 3);
    b.setId(3);
   b = l1.addItem("Wave Spin", 4);
    b.setId(4);
   b = l1.addItem("Meander", 5);
    b.setId(5);    
   b = l1.addItem("Tangle", 6);
    b.setId(6); 
   b = l1.addItem("Helix", 7);
    b.setId(7);     
   b = l1.addItem("Burst", 8);
    b.setId(8);     
   b = l1.addItem("City", 9);
    b.setId(9);     
   b = l1.addItem("Flip", 10);
    b.setId(10);     
   b = l1.addItem("Stairs", 11);
    b.setId(11);      
       b = l1.addItem("Fence", 12);
    b.setId(12);  

    lastX += myPApplet.round(myPApplet.width * .2f );

    ControlGroup l2 = controlP5.addGroup("myGroup2",lastX,11,myPApplet.round(myPApplet.width * .2f -1));
    l2.addCanvas(new MyCanvas( myPApplet.round(myPApplet.width * .2f -1), 100));
    l2.setLabel("Controls");
    Toggle t = controlP5.addToggle("Auto Pilot",true,4,4,10,10);
    t.setGroup(l2);
    t.setId(200);    
     t = controlP5.addToggle("Auto Visualizer",true,4,30,10,10);
    t.setGroup(l2);
    t.setId(201);
    t = controlP5.addToggle("Sudden Motion Sensor",false,4,56,10,10);
    t.setGroup(l2);
    t.setId(202);  
    
    lastX += myPApplet.round(myPApplet.width * .2f);    

    ControlGroup l3 = controlP5.addGroup("myGroup3",lastX,11,myPApplet.round(myPApplet.width * .2f -2));
    l3.addCanvas(new MyCanvas( myPApplet.round(myPApplet.width * .2f -2), 300));
    l3.setLabel("About");    
    Textarea tx = controlP5.addTextarea(
    "label1", 
    "TypeStar 1.0 by Scott Garner\n\nSong Controls:\n\nn:                Next Song\np:                Previous Song\nSPACE:           Play/Pause\n<,>:               Seek Back/Forward\n\n\nCamera Controls:\n\nMOUSE 1:         Tumble Camera\nSHIFT-MOUSE 1:   Dolly Camera\n\nUP, DOWN:        Boom Camera\nLEFT, RIGHT:      Truck Camera    \n1,3:               Dolly Camera\n4,6:              Circle Camera\n2,8:              Arc Camera\n7,9:              Roll Camera\n5:                Center Camera\n\nGeneral Controls:\n\na:                 Enable Autopilot\ns:                 Save Frame\nTAB:              Cycle Visualizer", 
    1,1,200,300);
    tx.setGroup(l3);

    Slider s = controlP5.addSlider("Position",0, 100, 1, myPApplet.height - 11, myPApplet.width-2, 10 );
    s.setId(302);
    return controlP5;
  }
}

class MyCanvas extends ControlCanvas {
  int canvasWidth = 0;
  int canvasHeight = 0;
  MyCanvas(int newWidth, int newHeight) {
    canvasWidth = newWidth;
    canvasHeight = newHeight;
  }

  public void draw(PApplet theApplet) {
    theApplet.fill(0,54,82);
    theApplet.rect(0,0,canvasWidth,canvasHeight);
  }
}


